;
; =========================================================
; PLAKAT.TXT Bo Engborg 851223 17.23
; =========================================================
;
PGMSTRT  ORG 63232
         JP PLAKAT
         JP BSAVE
;
ALLHEAPA LD A,D
         OR E
         RET Z                         ; Noll bytes
         LD (ANTAL),DE                 ; Spara f|r }terst{llande
         LD A,(ALLHEAP)
         CP 205
         JP Z,ALLHEAP                  ; Checksumma 11273
         JP ALLHEAP-9                  ; Checksumma 9913
;
NOHEAP   LD BC,(ANTAL)
         LD HL,(HEAP)
         AND A
         SBC HL,BC
         LD (HEAP),HL
         RET
;
BSAVE    LD A,(RADBRED)
         ADD A,4
         LD HL,0
         LD D,0
         LD E,A
         LD B,24
BSAVEGG  ADD HL,DE
         DJNZ BSAVEGG
         EX DE,HL
         CALL ALLHEAPA                 ; Allokera DE-bytes p} HEAP
;
         LD B,24
         CALL BDUMP
         CALL STR[NG
         PUSH IX
         CALL OUTFIL
         CALL GETFIL2                  ; Closefile
         POP IX
         CALL NOHEAP
         RET
;
PLAKAT   LD (WAIT),DE
         LD A,23
         CALL PLAKAT3
         CALL STR[NG
         LD B,C
PLAKAT1  PUSH BC                       ; BC=antal
         LD A,(HL)
         INC HL
         PUSH HL
         CALL PLAKAT3
         POP HL
         POP BC
         DJNZ PLAKAT1
         RET
;
PLAKAT3  LD C,A
         LD A,(65011)
         CP 23
         LD A,190                      ; Dotadress utanf|r sk{rmen
         JP NC,FELKOD1
         LD A,(590)
         LD B,A
         LD A,(65012)
         CP B
         LD A,190
         JP NC,FELKOD1
         LD A,C                        ; ]terst{ll ej utanf|r sk{rmen
         AND 127
         PUSH IX
         LD IX,65011
         LD HL,(65011)
         CP 13
         JR Z,CHR13
         CP 10
         JR Z,CHR10
         LD C,6
         CP 7
         JR Z,CHRGRAF2
         LD C,23
         CP 23
         JR Z,CHRGRAF2
         SUB 31
         INC H
         INC H
         INC H
         LD (RADADR),HL
         LD HL,VASTRT1-9
         LD B,A
         LD DE,9
PLAKAT3A ADD HL,DE
         DJNZ PLAKAT3A
PLAKAT3B LD B,3
PLAKAT3C PUSH BC
         CALL VIDEOW
         LD BC,3
         LDIR
         POP BC
         INC (IX)
         DJNZ PLAKAT3C
         LD HL,(RADADR)
         LD (65011),HL
PLAKEND  POP IX
         LD BC,(WAIT)
         CALL DELAY
         RET
;
CHRGRAF2 CALL CHRGRAF
         JR PLAKEND
;
CHRGRAF  LD B,3
CHRGRAF1 CALL VIDEOW
         LD A,C
         LD (DE),A
         INC (IX)
         DJNZ CHRGRAF1
         INC H
         LD (65011),HL
         RET
;
;
CHR10    INC (IX)
         INC (IX)
         INC (IX)
         JR PLAKEND
;
CHR13    LD C,6
         CALL CHRGRAF
         LD (IX+1),0
         JR CHR10
;
STR[NG   LD B,69
         LD C,11110010B                ; E$
         CALL FIND
         RET NC                        ; Funnen
         RST 16
         DEFB 128+21                   ; Hittar ej filen
;
;
FIND     LD HL,(VAROT)
         LD A,H
         OR L
         SCF
         RET Z                         ; Ingen variabellista finns
         PUSH IX
         LD IX,(VAROT)
FIND1    LD L,(IX+2)
         LD H,(IX+3)
         LD A,(IX+1)
         CP B
         JR NZ,FIND2
         LD A,(IX)
         CP C
         JR NZ,FIND2
         LD C,(IX+8)
         LD B,(IX+9)
         LD L,(IX+6)
         LD H,(IX+7)
         JR FOUND
FIND2    PUSH HL
         POP IX
         LD A,L
         OR H
         SCF
         JR Z,NOFOUND
         JR FIND1
FOUND    AND A
NOFOUND  POP IX
         RET
;
DELAY    LD A,B                        ; Delay sekunder BC*10,BC=100 10sek
         OR C
         RET Z
DELAY1   PUSH BC
         LD B,2
DELAY2   LD HL,9216
DELAY3   DEC L
         JR NZ,DELAY3
         DEC H
         JR NZ,DELAY3
         DJNZ DELAY2
         POP BC
         DEC BC
         JR DELAY
;
STRING   LD C,A
         LD A,B
         OR 0
         LD A,C
         RET Z
STRING1  LD (DE),A
         INC DE
         DJNZ STRING1
         RET
;
BDUMP    LD (BUFADR1),HL               ; Slut (r{knare)
         LD (MBUFFW),HL                ; Startbuffert
         EX DE,HL                      ; DE-->buffert
         LD A,(RADBRED)
         LD (DE),A
         INC DE
         LD A,13
         LD (DE),A
         INC DE                        ; Ladda med radbredd och CR
;
BDUMP1   PUSH IX
         LD IX,884
;
bdump2   PUSH BC
         LD L,(IX)
         LD H,(IX+1)
         INC IX
         INC IX
         LD A,(RADBRED)
         LD B,A
;
bdump3   LD A,(HL)
         AND 127
         CP 8
         JR C,bdump3A
         CP 24
         JR C,bdump3B
         CP 32
         JR NC,bdump3F
bdump3E  LD A,32
         JR bdump3F
bdump3A  LD A,6
         JR bdump3F
bdump3B  CP 17
         JR C,bdump3E
         LD A,23
bdump3F  LD (DE),A
         INC DE
         INC HL
         DJNZ bdump3
         LD A,13
         LD (DE),A
         INC DE
;
         POP BC
         DJNZ bdump2
         LD (BUFADR1),DE
         POP IX
         RET
;
;
;
; =====================================
; OPEN,PREPARE,CLOSE
; HL-->filnamn avsluta med CR
; =====================================
;
GETFIL2  LD DE,CLOSEF1
         LD (IX+5),0
         CALL FILCONTR
         RET
;
OUTFIL   LD A,1                        ; A=opentyp,B=filnummer
         LD B,127
         CALL FIL\PPN
;
OUTFIL1  LD HL,(MBUFFW)
         PUSH HL
         LD A,13
         LD BC,120
         CPIR
         LD (MBUFFW),HL
         LD DE,(BUFADR1)
         DEC HL
         SCF
         SBC HL,DE
         JR NC,outfil2a
         LD HL,120
         AND A
         SBC HL,BC
         PUSH HL
         POP BC
         POP HL
         LD DE,PRINTFIL
         CALL FILCONTR
         JR OUTFIL1
outfil2a POP HL
         RET                           ; Klart sedan close
;
;
;
FIL\PPN  LD IX,FILBESK                 ; HL-->Filnamn
         LD (IX+2),B
         LD DE,OPENCMD
         CALL FILCONTR
         RET
;
;
;
;
FILCONTR PUSH HL                       ; Rutinadress i DE
         LD HL,FELKOD
         EX (SP),HL
         LD (RUNSTACK),SP
         PUSH HL
         LD HL,feljmp
         PUSH AF
         XOR A
         LD (MIY14),A                  ; Run Mode
         LD (MIY14+1),A                  ; Notrace
         LD (MIY30),HL
         POP AF
         LD HL,filctr1
         EX (SP),HL
         PUSH DE
         RET
filctr1  POP HL
         RET                           ; Inga fel
feljmp   DEFB 4
         DEFB 0
         DEFB 1
         DEFB 145                      ; Basic-return
FELKOD   LD A,(MIY34)
FELKOD1  LD (ERROR),A
         LD SP,(RUNSTACK)
         RST 16
ERROR    DEFB 128
;
;
; 32 ( )  0000 0000/0010 0000/1010 0000
; #0:Set 5 / Pr:Set 7,5
VASTRT1  DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
; 33 (!)
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 42
         DEFB 32
         DEFB 32
         DEFB 34
         DEFB 32
; 34 (")
         DEFB 32
         DEFB 52
         DEFB 52
         DEFB 32
         DEFB 33
         DEFB 33
         DEFB 32
         DEFB 32
         DEFB 32
; 35 (#)
         DEFB 96
         DEFB 117
         DEFB 117
         DEFB 40
         DEFB 61
         DEFB 61
         DEFB 32
         DEFB 33
         DEFB 33
; 36 ($)
         DEFB 96
         DEFB 32
         DEFB 96
         DEFB 32
         DEFB 119
         DEFB 53
         DEFB 34
         DEFB 32
         DEFB 34
; 37 (%)
         DEFB 42
         DEFB 37
         DEFB 56
         DEFB 96
         DEFB 38
         DEFB 112
         DEFB 32
         DEFB 32
         DEFB 35
; 38 (&)
         DEFB 32
         DEFB 54
         DEFB 52
         DEFB 104
         DEFB 43
         DEFB 56
         DEFB 32
         DEFB 35
         DEFB 34
; 39 (')
         DEFB 32
         DEFB 96
         DEFB 37
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
; 40 (()
         DEFB 32
         DEFB 96
         DEFB 38
         DEFB 32
         DEFB 42
         DEFB 48
         DEFB 32
         DEFB 32
         DEFB 34
; 41 ())
         DEFB 34
         DEFB 100
         DEFB 32
         DEFB 32
         DEFB 58
         DEFB 32
         DEFB 34
         DEFB 32
         DEFB 32
; 42 (*)
         DEFB 40
         DEFB 122
         DEFB 56
         DEFB 96
         DEFB 110
         DEFB 100
         DEFB 32
         DEFB 34
         DEFB 32
; 43 (+)
         DEFB 32
         DEFB 104
         DEFB 32
         DEFB 34
         DEFB 107
         DEFB 35
         DEFB 32
         DEFB 32
         DEFB 32
; 44 (,)
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 96
         DEFB 32
         DEFB 32
         DEFB 38
         DEFB 32
; 45 (-)
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 35
         DEFB 33
         DEFB 32
         DEFB 32
         DEFB 32
; 46 (.)
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 96
         DEFB 48
         DEFB 32
         DEFB 34
         DEFB 33
         DEFB 32
; 47 (/)
         DEFB 32
         DEFB 32
         DEFB 56
         DEFB 96
         DEFB 38
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
; 48 (0)
         DEFB 104
         DEFB 35
         DEFB 105
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 49 (1)
         DEFB 32
         DEFB 110
         DEFB 32
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 35
         DEFB 33
; 50 (2)
         DEFB 40
         DEFB 35
         DEFB 105
         DEFB 96
         DEFB 38
         DEFB 33
         DEFB 34
         DEFB 35
         DEFB 35
; 51 (3)
         DEFB 34
         DEFB 35
         DEFB 59
         DEFB 96
         DEFB 34
         DEFB 105
         DEFB 32
         DEFB 35
         DEFB 33
; 52 (4)
         DEFB 32
         DEFB 56
         DEFB 53
         DEFB 42
         DEFB 44
         DEFB 61
         DEFB 32
         DEFB 32
         DEFB 33
; 53 (5)
         DEFB 106
         DEFB 115
         DEFB 51
         DEFB 96
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 54 (6)
         DEFB 96
         DEFB 38
         DEFB 35
         DEFB 106
         DEFB 35
         DEFB 105
         DEFB 32
         DEFB 35
         DEFB 33
; 55 (7)
         DEFB 34
         DEFB 35
         DEFB 59
         DEFB 32
         DEFB 54
         DEFB 32
         DEFB 32
         DEFB 33
         DEFB 32
; 56 (8)
         DEFB 104
         DEFB 35
         DEFB 105
         DEFB 104
         DEFB 35
         DEFB 105
         DEFB 32
         DEFB 35
         DEFB 33
; 57 (9)
         DEFB 104
         DEFB 35
         DEFB 105
         DEFB 32
         DEFB 35
         DEFB 59
         DEFB 34
         DEFB 35
         DEFB 32
; 58 (:)
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 34
         DEFB 32
         DEFB 32
         DEFB 34
         DEFB 32
         DEFB 32
; 59 (;)
         DEFB 96
         DEFB 32
         DEFB 32
         DEFB 98
         DEFB 32
         DEFB 32
         DEFB 38
         DEFB 32
         DEFB 32
; 60 (<)
         DEFB 32
         DEFB 56
         DEFB 33
         DEFB 34
         DEFB 100
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 33
; 61 (=)
         DEFB 96
         DEFB 112
         DEFB 112
         DEFB 96
         DEFB 112
         DEFB 112
         DEFB 32
         DEFB 32
         DEFB 32
; 62 (>)
         DEFB 32
         DEFB 41
         DEFB 48
         DEFB 32
         DEFB 96
         DEFB 38
         DEFB 32
         DEFB 33
         DEFB 32
; 63 (?)
         DEFB 38
         DEFB 35
         DEFB 105
         DEFB 32
         DEFB 40
         DEFB 33
         DEFB 32
         DEFB 34
         DEFB 32
; 64 (@)
         DEFB 96
         DEFB 120
         DEFB 113
         DEFB 106
         DEFB 44
         DEFB 36
         DEFB 34
         DEFB 35
         DEFB 35
; 65 (A)
         DEFB 96
         DEFB 38
         DEFB 100
         DEFB 106
         DEFB 35
         DEFB 107
         DEFB 34
         DEFB 32
         DEFB 34
; 66 (B)
         DEFB 106
         DEFB 35
         DEFB 105
         DEFB 106
         DEFB 35
         DEFB 105
         DEFB 34
         DEFB 35
         DEFB 33
; 67 (C)
         DEFB 104
         DEFB 35
         DEFB 41
         DEFB 106
         DEFB 32
         DEFB 96
         DEFB 32
         DEFB 35
         DEFB 33
; 68 (D)
         DEFB 106
         DEFB 35
         DEFB 105
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 34
         DEFB 35
         DEFB 33
; 69 (E)
         DEFB 106
         DEFB 35
         DEFB 35
         DEFB 106
         DEFB 35
         DEFB 33
         DEFB 34
         DEFB 35
         DEFB 35
; 70 (F)
         DEFB 106
         DEFB 35
         DEFB 35
         DEFB 106
         DEFB 35
         DEFB 33
         DEFB 34
         DEFB 32
         DEFB 32
; 71 (G)
         DEFB 104
         DEFB 35
         DEFB 41
         DEFB 106
         DEFB 32
         DEFB 100
         DEFB 32
         DEFB 35
         DEFB 35
; 72 (H)
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 106
         DEFB 35
         DEFB 107
         DEFB 34
         DEFB 32
         DEFB 34
; 73 (I)
         DEFB 32
         DEFB 107
         DEFB 33
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 35
         DEFB 33
; 74 (J)
         DEFB 32
         DEFB 32
         DEFB 53
         DEFB 96
         DEFB 32
         DEFB 53
         DEFB 32
         DEFB 35
         DEFB 32
; 75 (K)
         DEFB 106
         DEFB 96
         DEFB 38
         DEFB 106
         DEFB 41
         DEFB 48
         DEFB 34
         DEFB 32
         DEFB 34
; 76 (L)
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 34
         DEFB 35
         DEFB 35
; 77 (M)
         DEFB 106
         DEFB 100
         DEFB 110
         DEFB 106
         DEFB 34
         DEFB 106
         DEFB 34
         DEFB 32
         DEFB 34
; 78 (N)
         DEFB 106
         DEFB 48
         DEFB 106
         DEFB 106
         DEFB 34
         DEFB 110
         DEFB 34
         DEFB 32
         DEFB 34
; 79 (O)
         DEFB 104
         DEFB 35
         DEFB 105
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 80 (P)
         DEFB 106
         DEFB 35
         DEFB 105
         DEFB 106
         DEFB 35
         DEFB 33
         DEFB 34
         DEFB 32
         DEFB 32
; 81 (Q)
         DEFB 104
         DEFB 35
         DEFB 105
         DEFB 106
         DEFB 40
         DEFB 58
         DEFB 32
         DEFB 35
         DEFB 34
; 82 (R)
         DEFB 106
         DEFB 35
         DEFB 105
         DEFB 106
         DEFB 43
         DEFB 49
         DEFB 34
         DEFB 32
         DEFB 34
; 83 (S)
         DEFB 104
         DEFB 35
         DEFB 41
         DEFB 96
         DEFB 35
         DEFB 105
         DEFB 32
         DEFB 35
         DEFB 33
; 84 (T)
         DEFB 34
         DEFB 107
         DEFB 35
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 34
         DEFB 32
; 85 (U)
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 86 (V)
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 101
         DEFB 37
         DEFB 32
         DEFB 34
         DEFB 32
; 87 (W)
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 106
         DEFB 106
         DEFB 106
         DEFB 32
         DEFB 33
         DEFB 33
; 88 (X)
         DEFB 42
         DEFB 48
         DEFB 58
         DEFB 96
         DEFB 38
         DEFB 100
         DEFB 34
         DEFB 32
         DEFB 34
; 89 (Y)
         DEFB 42
         DEFB 48
         DEFB 58
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 34
         DEFB 32
; 90 (Z)
         DEFB 34
         DEFB 35
         DEFB 59
         DEFB 96
         DEFB 38
         DEFB 32
         DEFB 34
         DEFB 35
         DEFB 35
; 91 ([)
         DEFB 32
         DEFB 113
         DEFB 49
         DEFB 106
         DEFB 44
         DEFB 110
         DEFB 34
         DEFB 32
         DEFB 34
; 92 (\)
         DEFB 32
         DEFB 113
         DEFB 49
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 93 (])
         DEFB 32
         DEFB 114
         DEFB 48
         DEFB 106
         DEFB 44
         DEFB 110
         DEFB 34
         DEFB 32
         DEFB 34
; 94 (^)
         DEFB 96
         DEFB 33
         DEFB 97
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 95 (_)
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 34
         DEFB 35
         DEFB 35
; 96 (`) 0100 000/0110 0000/1100 0000
; #0: Set 5 / Pr: Set 7
         DEFB 32
         DEFB 120
         DEFB 49
         DEFB 106
         DEFB 44
         DEFB 46
         DEFB 32
         DEFB 35
         DEFB 33
; 97 (a)
         DEFB 32
         DEFB 112
         DEFB 48
         DEFB 96
         DEFB 44
         DEFB 110
         DEFB 32
         DEFB 35
         DEFB 35
; 98 (b)
         DEFB 106
         DEFB 112
         DEFB 48
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 34
         DEFB 35
         DEFB 33
; 99 (c)
         DEFB 32
         DEFB 112
         DEFB 112
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 34
         DEFB 35
         DEFB 35
; 100 (d)
         DEFB 32
         DEFB 112
         DEFB 122
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 35
; 101 (e)
         DEFB 32
         DEFB 112
         DEFB 48
         DEFB 106
         DEFB 44
         DEFB 38
         DEFB 32
         DEFB 35
         DEFB 33
; 102 (f)
         DEFB 32
         DEFB 104
         DEFB 33
         DEFB 32
         DEFB 107
         DEFB 33
         DEFB 32
         DEFB 34
         DEFB 32
; 103 (g)
         DEFB 32
         DEFB 112
         DEFB 112
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 115
         DEFB 59
; 104 (h)
         DEFB 106
         DEFB 112
         DEFB 48
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 34
         DEFB 32
         DEFB 34
; 105 (i)
         DEFB 32
         DEFB 114
         DEFB 32
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 35
         DEFB 33
; 106 (j)
         DEFB 32
         DEFB 114
         DEFB 32
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 38
         DEFB 32
; 107 (k)
         DEFB 106
         DEFB 32
         DEFB 48
         DEFB 106
         DEFB 102
         DEFB 32
         DEFB 34
         DEFB 32
         DEFB 33
; 108 (l)
         DEFB 34
         DEFB 53
         DEFB 32
         DEFB 32
         DEFB 53
         DEFB 32
         DEFB 34
         DEFB 35
         DEFB 32
; 109 (m)
         DEFB 96
         DEFB 48
         DEFB 112
         DEFB 106
         DEFB 106
         DEFB 106
         DEFB 34
         DEFB 34
         DEFB 34
; 110 (n)
         DEFB 96
         DEFB 112
         DEFB 48
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 34
         DEFB 32
         DEFB 34
; 111 (o)
         DEFB 32
         DEFB 112
         DEFB 48
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 112 (p)
         DEFB 96
         DEFB 112
         DEFB 48
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 106
         DEFB 35
         DEFB 33
; 113 (q)
         DEFB 32
         DEFB 112
         DEFB 112
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 107
; 114 (r)
         DEFB 32
         DEFB 48
         DEFB 112
         DEFB 32
         DEFB 55
         DEFB 32
         DEFB 32
         DEFB 33
         DEFB 32
; 115 (s)
         DEFB 32
         DEFB 112
         DEFB 112
         DEFB 34
         DEFB 44
         DEFB 100
         DEFB 34
         DEFB 35
         DEFB 33
; 116 (t)
         DEFB 32
         DEFB 122
         DEFB 48
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 32
         DEFB 32
         DEFB 33
; 117 (u)
         DEFB 96
         DEFB 32
         DEFB 96
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 35
; 118 (v)
         DEFB 96
         DEFB 32
         DEFB 96
         DEFB 34
         DEFB 52
         DEFB 54
         DEFB 32
         DEFB 34
         DEFB 32
; 119 (w)
         DEFB 96
         DEFB 32
         DEFB 96
         DEFB 106
         DEFB 96
         DEFB 106
         DEFB 32
         DEFB 33
         DEFB 33
; 120 (x)
         DEFB 96
         DEFB 32
         DEFB 96
         DEFB 32
         DEFB 57
         DEFB 49
         DEFB 34
         DEFB 32
         DEFB 34
; 121 (y)
         DEFB 96
         DEFB 32
         DEFB 96
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 115
         DEFB 59
; 122 (z)
         DEFB 96
         DEFB 112
         DEFB 112
         DEFB 32
         DEFB 56
         DEFB 33
         DEFB 34
         DEFB 35
         DEFB 35
; 123 ({)
         DEFB 32
         DEFB 113
         DEFB 49
         DEFB 96
         DEFB 44
         DEFB 110
         DEFB 32
         DEFB 35
         DEFB 35
; 124 (|)
         DEFB 32
         DEFB 113
         DEFB 49
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 125 (})
         DEFB 32
         DEFB 114
         DEFB 48
         DEFB 96
         DEFB 44
         DEFB 110
         DEFB 32
         DEFB 35
         DEFB 35
; 126 (~)
         DEFB 32
         DEFB 36
         DEFB 36
         DEFB 106
         DEFB 32
         DEFB 106
         DEFB 32
         DEFB 35
         DEFB 33
; 127 ()
         DEFB 106
         DEFB 127
         DEFB 127
         DEFB 106
         DEFB 127
         DEFB 127
         DEFB 34
         DEFB 35
         DEFB 35
VAEND1   DEFB 255
;
; =====================================
; TEXT
; =====================================
;
VASTRT2  DEFB 255
BUFADR1  DEFS 2
FILBESK  DEFS 16                       ; Filbeskrivning
MBUFFW   DEFS 2                        ; Adress till buffert
RADADR   DEFS 2
WAIT     DEFS 2                        ; Save Delaytid/10 sek
ANTAL    DEFS 2                        ; Antal HEAP-allokerade bytes
VAEND2   DEFB 255
;
; VARIABELEND
; =====================================
;
;
PGMEND   DEFB 255
;
;
; =====================================
; KONSTANTER :::::------>
; =====================================
;
; _____________________________________
TXTBUF1  EQU 65088
ALLHEAP  EQU 13172                     ; Allokera antal bytes i DE p} HEAP
CLOSEF1  EQU 2192
OPENCMD  EQU 62                        ; HL-->filnamn
                                       ; Fixa IX-reg 3 f|rsta bytes
VIDEOW   EQU 659                       ; Bildadress enl 65011,12
RADBRED  EQU 590                       ; 40/80 tkn
MIY14    EQU 65060                     ; IY+14
MIY30    EQU 65076
MIY34    EQU 65080                     ; Felkod
BOFAW    EQU 65052                     ; -->BOFA
RUNSTACK EQU 65078
HEAP     EQU 65056                     ; Ledigt f|r tolken vid exekverbasic
VAROT    EQU 65065                     ; Variabelrot
TXTBUF3  EQU 65208                     ; Radcompilebuffert
FORMFILL EQU 630                       ; CHR$(12)
PRINTFIL EQU 2198                      ; HL->txtarea,BC=n,filbeskr.IX
BKONST21 EQU 32722                     ; Felmeddelande start
KONST1   EQU 37+128
KONST2   EQU 35+128
;
; =====================================
; KONSTANTER END
; =====================================
; ---->>>>>>
;
         END
